
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProductsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.create(
            {
                id: data.id || undefined,
        
        sku: data.sku
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        sale_price_ht: data.sale_price_ht
        ||
        null
            ,
            
        purchase_price_ht: data.purchase_price_ht
        ||
        null
            ,
            
        stock_on_hand: data.stock_on_hand
        ||
        null
            ,
            
        stock_reserved: data.stock_reserved
        ||
        null
            ,
            
        reorder_level: data.reorder_level
        ||
        null
            ,
            
        weighted_avg_cost: data.weighted_avg_cost
        ||
        null
            ,
            
        track_stock: data.track_stock
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await products.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await products.setCategory( data.category || null, {
            transaction,
        });
        
        await products.setUnit( data.unit || null, {
            transaction,
        });
        
        await products.setTax_rate( data.tax_rate || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sku: item.sku
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                sale_price_ht: item.sale_price_ht
            ||
            null
            ,
            
                purchase_price_ht: item.purchase_price_ht
            ||
            null
            ,
            
                stock_on_hand: item.stock_on_hand
            ||
            null
            ,
            
                stock_reserved: item.stock_reserved
            ||
            null
            ,
            
                reorder_level: item.reorder_level
            ||
            null
            ,
            
                weighted_avg_cost: item.weighted_avg_cost
            ||
            null
            ,
            
                track_stock: item.track_stock
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const products = await db.products.bulkCreate(productsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < products.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.products.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: products[i].id,
                },
                data[i].images,
                options,
            );
        }
        

        return products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const products = await db.products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sku !== undefined) updatePayload.sku = data.sku;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.sale_price_ht !== undefined) updatePayload.sale_price_ht = data.sale_price_ht;
        
        
        if (data.purchase_price_ht !== undefined) updatePayload.purchase_price_ht = data.purchase_price_ht;
        
        
        if (data.stock_on_hand !== undefined) updatePayload.stock_on_hand = data.stock_on_hand;
        
        
        if (data.stock_reserved !== undefined) updatePayload.stock_reserved = data.stock_reserved;
        
        
        if (data.reorder_level !== undefined) updatePayload.reorder_level = data.reorder_level;
        
        
        if (data.weighted_avg_cost !== undefined) updatePayload.weighted_avg_cost = data.weighted_avg_cost;
        
        
        if (data.track_stock !== undefined) updatePayload.track_stock = data.track_stock;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await products.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await products.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.category !== undefined) {
            await products.setCategory(
              
              data.category,
              
              { transaction }
            );
        }
        
        if (data.unit !== undefined) {
            await products.setUnit(
              
              data.unit,
              
              { transaction }
            );
        }
        
        if (data.tax_rate !== undefined) {
            await products.setTax_rate(
              
              data.tax_rate,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of products) {
                await record.destroy({transaction});
            }
        });


        return products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findByPk(id, options);

        await products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await products.destroy({
            transaction
        });

        return products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findOne(
            { where },
            { transaction },
        );

        if (!products) {
            return products;
        }

        const output = products.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.quote_items_product = await products.getQuote_items_product({
            transaction
        });
        
        
        
        output.sales_order_items_product = await products.getSales_order_items_product({
            transaction
        });
        
        
        
        output.delivery_note_items_product = await products.getDelivery_note_items_product({
            transaction
        });
        
        
        
        output.invoice_items_product = await products.getInvoice_items_product({
            transaction
        });
        
        
        
        
        output.credit_note_items_product = await products.getCredit_note_items_product({
            transaction
        });
        
        
        
        output.purchase_order_items_product = await products.getPurchase_order_items_product({
            transaction
        });
        
        
        
        output.stock_reception_items_product = await products.getStock_reception_items_product({
            transaction
        });
        
        
        output.stock_reservations_product = await products.getStock_reservations_product({
            transaction
        });
        
        
        output.stock_movements_product = await products.getStock_movements_product({
            transaction
        });
        
        
        
        output.inventory_count_items_product = await products.getInventory_count_items_product({
            transaction
        });
        
        
        
        
        
        output.organization = await products.getOrganization({
            transaction
        });
        
        
        output.category = await products.getCategory({
            transaction
        });
        
        
        output.unit = await products.getUnit({
            transaction
        });
        
        
        output.tax_rate = await products.getTax_rate({
            transaction
        });
        
        
        output.images = await products.getImages({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.product_categories,
        as: 'category',
        
        where: filter.category ? {
          [Op.or]: [
            { id: { [Op.in]: filter.category.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.category.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.units,
        as: 'unit',
        
        where: filter.unit ? {
          [Op.or]: [
            { id: { [Op.in]: filter.unit.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.unit.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tax_rates,
        as: 'tax_rate',
        
        where: filter.tax_rate ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tax_rate.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tax_rate.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.sku) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'sku',
                        filter.sku,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.sale_price_htRange) {
                const [start, end] = filter.sale_price_htRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sale_price_ht: {
                    ...where.sale_price_ht,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sale_price_ht: {
                    ...where.sale_price_ht,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.purchase_price_htRange) {
                const [start, end] = filter.purchase_price_htRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    purchase_price_ht: {
                    ...where.purchase_price_ht,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    purchase_price_ht: {
                    ...where.purchase_price_ht,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.stock_on_handRange) {
                const [start, end] = filter.stock_on_handRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    stock_on_hand: {
                    ...where.stock_on_hand,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    stock_on_hand: {
                    ...where.stock_on_hand,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.stock_reservedRange) {
                const [start, end] = filter.stock_reservedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    stock_reserved: {
                    ...where.stock_reserved,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    stock_reserved: {
                    ...where.stock_reserved,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reorder_levelRange) {
                const [start, end] = filter.reorder_levelRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.weighted_avg_costRange) {
                const [start, end] = filter.weighted_avg_costRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    weighted_avg_cost: {
                    ...where.weighted_avg_cost,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    weighted_avg_cost: {
                    ...where.weighted_avg_cost,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.track_stock) {
                where = {
                    ...where,
                track_stock: filter.track_stock,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'products',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.products.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

